Index: src/xc/xc_libxc.F
===================================================================
--- src/xc/xc_libxc.F	(revision 18250)
+++ src/xc/xc_libxc.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -9,17 +9,6 @@
 !>      LibXC:
 !>      (Marques, Oliveira, Burnus, CPC 183, 2272 (2012)).
 !>
-!>      For subsequent versions of libxc, the following should be updated if
-!>      necessary:
-!>      1) The list of functionals for which it is possible to provide input
-!>         parameters (in 'xc_libxc_wrap_functional_set_params'). For more
-!>         information on the parameters, see subroutines xc_f90_xxx_set_par
-!>         in libxc.f90 of the libxc package or xc_f90_lib_m.F.
-!>         only checked for functionals up to 2.0.1
-!>      2) Reactivate the functionals which are working correctly
-!>         (in 'xc_libxc_wrap_functional_buggy').
-!>         only checked for functionals up to 3.x.x
-!>
 !>      WARNING: In the subroutine libxc_lsd_calc, it could be that the
 !>      ordering for the 1st index of v2lapltau, v2rholapl, v2rhotau,
 !>      v2sigmalapl and v2sigmatau is not correct. For the moment it does not
@@ -30,13 +19,12 @@
 !>      01.2013 created [F. Tran]
 !>      07.2014 updates to versions 2.1 [JGH]
 !>      08.2015 refactoring [A. Gloess (agloess)]
+!>      01.2018 refactoring [A. Gloess (agloess)]
 !> \author F. Tran
 ! **************************************************************************************************
 MODULE xc_libxc
-#if defined(__LIBXC2) || defined(__LIBXC3)
-#define __LIBXC
-#endif
-  USE bibliography,                    ONLY: Marques2012,&
+  USE bibliography,                    ONLY: Lehtola2018,&
+                                             Marques2012,&
                                              cite_reference
 
   USE input_section_types,             ONLY: section_vals_type,&
@@ -51,27 +39,29 @@
   USE xc_rho_set_types,                ONLY: xc_rho_set_get,&
                                              xc_rho_set_type
 #if defined (__LIBXC)
-  USE xc_libxc_wrap,                   ONLY: xc_f90_pointer_t,&
-                                             xc_f90_func_init,&
-                                             xc_f90_func_end,&
-                                             xc_f90_info_family,&
-                                             xc_f90_info_kind,&
-                                             xc_f90_info_name,&
-                                             xc_f90_gga_exc,&
-                                             xc_f90_gga_exc_vxc,&
-                                             xc_f90_gga_fxc,&
-                                             xc_f90_gga_vxc,&
-                                             xc_f90_lda,&
-                                             xc_f90_lda_exc,&
-                                             xc_f90_lda_exc_vxc,&
-                                             xc_f90_lda_fxc,&
-                                             xc_f90_lda_kxc,&
-                                             xc_f90_lda_vxc,&
-                                             xc_f90_mgga,&
-                                             xc_f90_mgga_exc,&
-                                             xc_f90_mgga_exc_vxc,&
-                                             xc_f90_mgga_fxc,&
-                                             xc_f90_mgga_vxc,&
+  USE xc_libxc_wrap,                   ONLY: xc_f03_func_t,&
+                                             xc_f03_func_init,&
+                                             xc_f03_func_end,&
+                                             xc_f03_func_info_t,&
+                                             xc_f03_func_get_info,&
+                                             xc_f03_func_info_get_family,&
+                                             xc_f03_func_info_get_kind,&
+                                             xc_f03_func_info_get_name,&
+                                             xc_f03_gga_exc,&
+                                             xc_f03_gga_exc_vxc,&
+                                             xc_f03_gga_fxc,&
+                                             xc_f03_gga_vxc,&
+                                             xc_f03_lda,&
+                                             xc_f03_lda_exc,&
+                                             xc_f03_lda_exc_vxc,&
+                                             xc_f03_lda_fxc,&
+                                             xc_f03_lda_kxc,&
+                                             xc_f03_lda_vxc,&
+                                             xc_f03_mgga,&
+                                             xc_f03_mgga_exc,&
+                                             xc_f03_mgga_exc_vxc,&
+                                             xc_f03_mgga_fxc,&
+                                             xc_f03_mgga_vxc,&
                                              XC_POLARIZED,&
                                              XC_UNPOLARIZED,&
                                              XC_FAMILY_LDA,&
@@ -86,8 +76,7 @@
                                              xc_libxc_wrap_version,&
                                              xc_libxc_wrap_functional_get_number,&
                                              xc_libxc_wrap_needs_laplace,&
-                                             xc_libxc_wrap_functional_set_params,&
-                                             xc_libxc_wrap_functional_buggy
+                                             xc_libxc_wrap_functional_set_params
 #endif
 
 #include "../base/base_uses.f90"
@@ -110,65 +99,59 @@
 !> \param needs the components needed by this functional are set to
 !>        true (does not set the unneeded components to false)
 !> \param max_deriv maximum implemented derivative of the xc functional
-!> \param ifunc_name the index of the functional as given in the input file
 !> \author F. Tran
 ! **************************************************************************************************
-   SUBROUTINE libxc_lda_info(libxc_params, reference, shortform, needs, max_deriv, ifunc_name)
+   SUBROUTINE libxc_lda_info(libxc_params, reference, shortform, needs, max_deriv)
 
       TYPE(section_vals_type), POINTER         :: libxc_params
       CHARACTER(LEN=*), INTENT(OUT), OPTIONAL  :: reference, shortform
       TYPE(xc_rho_cflags_type), &
-         INTENT(inout), OPTIONAL                :: needs
+         INTENT(inout), OPTIONAL               :: needs
       INTEGER, INTENT(out), OPTIONAL           :: max_deriv
-      INTEGER, INTENT(in)                      :: ifunc_name
 
       CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lda_info', &
                                      routineP = moduleN//':'//routineN
 
 #if defined (__LIBXC)
-      CHARACTER(LEN=120)                       :: s1, s2
-      CHARACTER(LEN=default_string_length), &
-         DIMENSION(:), POINTER                  :: func_name
+      CHARACTER(LEN=128)                       :: s1, s2
+      CHARACTER(LEN=default_string_length)     :: func_name
       INTEGER                                  :: func_id
-      REAL(KIND=dp)                            :: sc
-      REAL(KIND=dp), DIMENSION(:), POINTER     :: scale
-      TYPE(xc_f90_pointer_t)                   :: xc_func, xc_info
+      REAL(KIND=dp)                            :: func_scale
+      TYPE(xc_f03_func_t)                      :: xc_func
+      TYPE(xc_f03_func_info_t)                 :: xc_info
 
-      CALL section_vals_val_get(libxc_params, "functional", c_vals=func_name)
-      CALL section_vals_val_get(libxc_params, "scale", r_vals=scale)
+      CALL section_vals_val_get(libxc_params, "functional", c_val=func_name)
+      CALL section_vals_val_get(libxc_params, "scale", r_val=func_scale)
 
       CALL cite_reference(Marques2012)
+      CALL cite_reference(Lehtola2018)
 
-      IF ((SIZE(scale) == 1) .AND. (ABS(SCALE(1)-1.0_dp) < 1.0e-10_dp)) THEN
-         sc = 1.0_dp
-      ELSE
-         sc = SCALE(ifunc_name)
-      ENDIF
+      IF (ABS(func_scale-1.0_dp) < 1.0e-10_dp) func_scale = 1.0_dp
 
-      func_id = xc_libxc_wrap_functional_get_number(func_name(ifunc_name))
-      CALL xc_libxc_wrap_functional_buggy(func_id)
+      func_id = xc_libxc_wrap_functional_get_number(func_name)
 !$OMP CRITICAL(libxc_init)
-      CALL xc_f90_func_init(xc_func, xc_info, func_id, XC_UNPOLARIZED)
+      CALL xc_f03_func_init(xc_func, func_id, XC_UNPOLARIZED)
+      xc_info = xc_f03_func_get_info(xc_func)
 !$OMP END CRITICAL(libxc_init)
 !$OMP BARRIER
 
-      CALL xc_f90_info_name(xc_info, s1)
-      SELECT CASE (xc_f90_info_kind (xc_info))
+      s1 = xc_f03_func_info_get_name(xc_info)
+      SELECT CASE (xc_f03_func_info_get_kind (xc_info))
       CASE (XC_EXCHANGE); WRITE (s2, '(a)') "exchange"
       CASE (XC_CORRELATION); WRITE (s2, '(a)') "correlation"
       CASE (XC_EXCHANGE_CORRELATION); WRITE (s2, '(a)') "exchange-correlation"
       CASE (XC_KINETIC); WRITE (s2, '(a)') "kinetic"
       CASE default
-         CPABORT(TRIM(func_name(ifunc_name))//": this XC_KIND is currently not supported.")
+         CPABORT(TRIM(func_name)//": this XC_KIND is currently not supported.")
       END SELECT
       IF (PRESENT(shortform)) THEN
          shortform = TRIM(s1)//' ('//TRIM(s2)//')'
       END IF
       IF (PRESENT(reference)) THEN
-         CALL xc_libxc_wrap_info_refs(xc_info, XC_UNPOLARIZED, sc, reference)
+         CALL xc_libxc_wrap_info_refs(xc_info, XC_UNPOLARIZED, func_scale, reference)
       END IF
       IF (PRESENT(needs)) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             needs%rho = .TRUE.
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA)
@@ -180,11 +163,11 @@
             needs%tau = .TRUE.
             needs%laplace_rho = xc_libxc_wrap_needs_laplace(func_id)
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (PRESENT(max_deriv)) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             max_deriv = 3
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA)
@@ -192,12 +175,17 @@
          CASE (XC_FAMILY_MGGA)
             max_deriv = 1
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
 
-      CALL xc_f90_func_end(xc_func)
+      CALL xc_f03_func_end(xc_func)
 #else
+      MARK_USED(libxc_params)
+      MARK_USED(reference)
+      MARK_USED(shortform)
+      MARK_USED(needs)
+      MARK_USED(max_deriv)
       CPABORT("In order to use libxc you need to download and install it")
 #endif
 
@@ -211,65 +199,59 @@
 !> \param needs the components needed by this functional are set to
 !>        true (does not set the unneeded components to false)
 !> \param max_deriv maximum implemented derivative of the xc functional
-!> \param ifunc_name the index of the functional as given in the input file
 !> \author F. Tran
 ! **************************************************************************************************
-   SUBROUTINE libxc_lsd_info(libxc_params, reference, shortform, needs, max_deriv, ifunc_name)
+   SUBROUTINE libxc_lsd_info(libxc_params, reference, shortform, needs, max_deriv)
 
       TYPE(section_vals_type), POINTER         :: libxc_params
       CHARACTER(LEN=*), INTENT(OUT), OPTIONAL  :: reference, shortform
       TYPE(xc_rho_cflags_type), &
-         INTENT(inout), OPTIONAL                :: needs
+         INTENT(inout), OPTIONAL               :: needs
       INTEGER, INTENT(out), OPTIONAL           :: max_deriv
-      INTEGER, INTENT(in)                      :: ifunc_name
 
       CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lsd_info', &
                                      routineP = moduleN//':'//routineN
 
 #if defined (__LIBXC)
-      CHARACTER(LEN=120)                       :: s1, s2
-      CHARACTER(LEN=default_string_length), &
-         DIMENSION(:), POINTER                  :: func_name
+      CHARACTER(LEN=128)                       :: s1, s2
+      CHARACTER(LEN=default_string_length)     :: func_name
       INTEGER                                  :: func_id
-      REAL(KIND=dp)                            :: sc
-      REAL(KIND=dp), DIMENSION(:), POINTER     :: scale
-      TYPE(xc_f90_pointer_t)                   :: xc_func, xc_info
+      REAL(KIND=dp)                            :: func_scale
+      TYPE(xc_f03_func_t)                      :: xc_func
+      TYPE(xc_f03_func_info_t)                 :: xc_info
 
-      CALL section_vals_val_get(libxc_params, "functional", c_vals=func_name)
-      CALL section_vals_val_get(libxc_params, "scale", r_vals=scale)
+      CALL section_vals_val_get(libxc_params, "functional", c_val=func_name)
+      CALL section_vals_val_get(libxc_params, "scale", r_val=func_scale)
 
       CALL cite_reference(Marques2012)
+      CALL cite_reference(Lehtola2018)
 
-      IF ((SIZE(scale) == 1) .AND. (ABS(SCALE(1)-1.0_dp) < 1.0e-10_dp)) THEN
-         sc = 1.0_dp
-      ELSE
-         sc = SCALE(ifunc_name)
-      ENDIF
+      IF (ABS(func_scale-1.0_dp) < 1.0e-10_dp) func_scale = 1.0_dp
 
-      func_id = xc_libxc_wrap_functional_get_number(func_name(ifunc_name))
-      CALL xc_libxc_wrap_functional_buggy(func_id)
+      func_id = xc_libxc_wrap_functional_get_number(func_name)
 !$OMP CRITICAL(libxc_init)
-      CALL xc_f90_func_init(xc_func, xc_info, func_id, XC_POLARIZED)
+      CALL xc_f03_func_init(xc_func, func_id, XC_POLARIZED)
+      xc_info = xc_f03_func_get_info(xc_func)
 !$OMP END CRITICAL(libxc_init)
 !$OMP BARRIER
 
-      CALL xc_f90_info_name(xc_info, s1)
-      SELECT CASE (xc_f90_info_kind (xc_info))
+      s1 = xc_f03_func_info_get_name(xc_info)
+      SELECT CASE (xc_f03_func_info_get_kind (xc_info))
       CASE (XC_EXCHANGE); WRITE (s2, '(a)') "exchange"
       CASE (XC_CORRELATION); WRITE (s2, '(a)') "correlation"
       CASE (XC_EXCHANGE_CORRELATION); WRITE (s2, '(a)') "exchange-correlation"
       CASE (XC_KINETIC); WRITE (s2, '(a)') "kinetic"
       CASE default
-         CPABORT(TRIM(func_name(ifunc_name))//": this XC_KIND is currently not supported.")
+         CPABORT(TRIM(func_name)//": this XC_KIND is currently not supported.")
       END SELECT
       IF (PRESENT(shortform)) THEN
          shortform = TRIM(s1)//' ('//TRIM(s2)//')'
       END IF
       IF (PRESENT(reference)) THEN
-         CALL xc_libxc_wrap_info_refs(xc_info, XC_POLARIZED, sc, reference)
+         CALL xc_libxc_wrap_info_refs(xc_info, XC_POLARIZED, func_scale, reference)
       END IF
       IF (PRESENT(needs)) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             needs%rho_spin = .TRUE.
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA)
@@ -283,11 +265,11 @@
             needs%tau_spin = .TRUE.
             needs%laplace_rho_spin = xc_libxc_wrap_needs_laplace(func_id)
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (PRESENT(max_deriv)) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             max_deriv = 3
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA)
@@ -295,12 +277,17 @@
          CASE (XC_FAMILY_MGGA)
             max_deriv = 1
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
 
-      CALL xc_f90_func_end(xc_func)
+      CALL xc_f03_func_end(xc_func)
 #else
+      MARK_USED(libxc_params)
+      MARK_USED(reference)
+      MARK_USED(shortform)
+      MARK_USED(needs)
+      MARK_USED(max_deriv)
       CPABORT("In order to use libxc you need to download and install it")
 #endif
 
@@ -335,35 +322,33 @@
 !>        if positive all the derivatives up to the given degree are evaluated,
 !>        if negative only the given degree is calculated
 !> \param libxc_params input parameter (functional name, scaling and parameters)
-!> \param ifunc_name the index of the functional as given in the input file
 !> \author F. Tran
 ! **************************************************************************************************
-   SUBROUTINE libxc_lda_eval(rho_set, deriv_set, grad_deriv, libxc_params, ifunc_name)
+   SUBROUTINE libxc_lda_eval(rho_set, deriv_set, grad_deriv, libxc_params)
 
       TYPE(xc_rho_set_type), POINTER           :: rho_set
       TYPE(xc_derivative_set_type), POINTER    :: deriv_set
       INTEGER, INTENT(in)                      :: grad_deriv
       TYPE(section_vals_type), POINTER         :: libxc_params
-      INTEGER, INTENT(in)                      :: ifunc_name
 
       CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lda_eval', &
                                      routineP = moduleN//':'//routineN
 
 #if defined (__LIBXC)
-      CHARACTER(LEN=default_string_length), &
-         DIMENSION(:), POINTER                  :: func_name
+      CHARACTER(LEN=default_string_length)     :: func_name
       INTEGER                                  :: func_id, handle, npoints
       INTEGER, DIMENSION(:, :), POINTER        :: bo
       LOGICAL                                  :: has_laplace
-      REAL(KIND=dp)                            :: epsilon_rho, epsilon_tau, sc
-      REAL(KIND=dp), DIMENSION(:), POINTER     :: params, scale
+      REAL(KIND=dp)                            :: epsilon_rho, epsilon_tau, func_scale
+      REAL(KIND=dp), DIMENSION(:), POINTER     :: params
       REAL(KIND=dp), DIMENSION(:, :, :), POINTER :: dummy, e_0, e_laplace_rho, &
                                                     e_laplace_rho_laplace_rho, e_laplace_rho_tau, e_ndrho, &
                                                     e_ndrho_laplace_rho, e_ndrho_ndrho, e_ndrho_rho, e_ndrho_tau, e_rho, &
                                                     e_rho_laplace_rho, e_rho_rho, e_rho_rho_rho, e_rho_tau, e_tau, &
                                                     e_tau_tau, laplace_rho, norm_drho, rho, tau
       TYPE(xc_derivative_type), POINTER        :: deriv
-      TYPE(xc_f90_pointer_t)                   :: xc_func, xc_info
+      TYPE(xc_f03_func_t)                      :: xc_func
+      TYPE(xc_f03_func_info_t)                 :: xc_info
 
       CALL timeset(routineN, handle)
 
@@ -376,20 +361,16 @@
       CPASSERT(ASSOCIATED(deriv_set))
       CPASSERT(deriv_set%ref_count > 0)
 
-      CALL section_vals_val_get(libxc_params, "functional", c_vals=func_name)
-      CALL section_vals_val_get(libxc_params, "scale", r_vals=scale)
+      CALL section_vals_val_get(libxc_params, "functional", c_val=func_name)
+      CALL section_vals_val_get(libxc_params, "scale", r_val=func_scale)
       CALL section_vals_val_get(libxc_params, "parameters", r_vals=params)
 
-      IF ((SIZE(scale) == 1) .AND. (ABS(SCALE(1)-1.0_dp) < 1.0e-10_dp)) THEN
-         sc = 1.0_dp
-      ELSE
-         sc = SCALE(ifunc_name)
-      ENDIF
+      IF (ABS(func_scale-1.0_dp) < 1.0e-10_dp) func_scale = 1.0_dp
 
-      func_id = xc_libxc_wrap_functional_get_number(func_name(ifunc_name))
-      CALL xc_libxc_wrap_functional_buggy(func_id, grad_deriv=grad_deriv)
+      func_id = xc_libxc_wrap_functional_get_number(func_name)
 !$OMP CRITICAL(libxc_init)
-      CALL xc_f90_func_init(xc_func, xc_info, func_id, XC_UNPOLARIZED)
+      CALL xc_f03_func_init(xc_func, func_id, XC_UNPOLARIZED)
+      xc_info = xc_f03_func_get_info(xc_func)
 !$OMP END CRITICAL(libxc_init)
 !$OMP BARRIER
 
@@ -434,7 +415,7 @@
          CALL xc_derivative_get(deriv, deriv_data=e_0)
       END IF
       IF (grad_deriv >= 1 .OR. grad_deriv == -1) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rho)", &
                                             allocate_deriv=.TRUE.)
@@ -462,11 +443,11 @@
                CALL xc_derivative_get(deriv, deriv_data=e_laplace_rho)
             END IF
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 2 .OR. grad_deriv == -2) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rho)(rho)", &
                                             allocate_deriv=.TRUE.)
@@ -518,11 +499,11 @@
             !                CALL xc_derivative_get(deriv,deriv_data=e_laplace_rho_tau)
             !             END IF
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 3 .OR. grad_deriv == -3) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rho)(rho)(rho)", &
                                             allocate_deriv=.TRUE.)
@@ -530,7 +511,7 @@
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA, XC_FAMILY_MGGA)
             CPABORT("derivatives larger than 2 not implemented")
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 4 .OR. grad_deriv <= -4) THEN
@@ -544,7 +525,7 @@
 !$OMP SHARED(e_laplace_rho_tau,e_tau_tau,e_rho_rho_rho),&
 !$OMP SHARED(grad_deriv,npoints),&
 !$OMP SHARED(epsilon_rho,epsilon_tau),&
-!$OMP SHARED(func_name,ifunc_name,sc,params)
+!$OMP SHARED(func_name,func_scale,params)
 
       CALL libxc_lda_calc(rho=rho, norm_drho=norm_drho, &
                           laplace_rho=laplace_rho, tau=tau, &
@@ -557,17 +538,21 @@
                           e_rho_rho_rho=e_rho_rho_rho, &
                           grad_deriv=grad_deriv, npoints=npoints, &
                           epsilon_rho=epsilon_rho, &
-                          epsilon_tau=epsilon_tau, func_name=func_name(ifunc_name), &
-                          sc=sc, params=params)
+                          epsilon_tau=epsilon_tau, func_name=func_name, &
+                          sc=func_scale, params=params)
 
 !$OMP END PARALLEL
 
       NULLIFY (dummy)
 
-      CALL xc_f90_func_end(xc_func)
+      CALL xc_f03_func_end(xc_func)
 
       CALL timestop(handle)
 #else
+      MARK_USED(rho_set)
+      MARK_USED(deriv_set)
+      MARK_USED(grad_deriv)
+      MARK_USED(libxc_params)
       CPABORT("In order to use libxc you need to download and install it")
 #endif
    END SUBROUTINE libxc_lda_eval
@@ -581,28 +566,25 @@
 !>        if positive all the derivatives up to the given degree are evaluated,
 !>        if negative only the given degree is calculated
 !> \param libxc_params input parameter (functional name, scaling and parameters)
-!> \param ifunc_name the index of the functional as given in the input file
 !> \author F. Tran
 ! **************************************************************************************************
-   SUBROUTINE libxc_lsd_eval(rho_set, deriv_set, grad_deriv, libxc_params, ifunc_name)
+   SUBROUTINE libxc_lsd_eval(rho_set, deriv_set, grad_deriv, libxc_params)
 
       TYPE(xc_rho_set_type), POINTER           :: rho_set
       TYPE(xc_derivative_set_type), POINTER    :: deriv_set
       INTEGER, INTENT(in)                      :: grad_deriv
       TYPE(section_vals_type), POINTER         :: libxc_params
-      INTEGER, INTENT(in)                      :: ifunc_name
 
       CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lsd_eval', &
                                      routineP = moduleN//':'//routineN
 
 #if defined (__LIBXC)
-      CHARACTER(LEN=default_string_length), &
-         DIMENSION(:), POINTER                  :: func_name
+      CHARACTER(LEN=default_string_length)     :: func_name
       INTEGER                                  :: func_id, handle, npoints
       INTEGER, DIMENSION(:, :), POINTER        :: bo
       LOGICAL                                  :: has_laplace
-      REAL(KIND=dp)                            :: epsilon_rho, epsilon_tau, sc
-      REAL(KIND=dp), DIMENSION(:), POINTER     :: params, scale
+      REAL(KIND=dp)                            :: epsilon_rho, epsilon_tau, func_scale
+      REAL(KIND=dp), DIMENSION(:), POINTER     :: params
       REAL(KIND=dp), DIMENSION(:, :, :), POINTER :: dummy, e_0, e_laplace_rhoa, &
                                                     e_laplace_rhoa_laplace_rhoa, e_laplace_rhoa_laplace_rhob, &
                                                     e_laplace_rhoa_tau_a, e_laplace_rhoa_tau_b, e_laplace_rhob, &
@@ -623,7 +605,8 @@
                                                     e_tau_a_tau_b, e_tau_b, e_tau_b_tau_b, laplace_rhoa, laplace_rhob, &
                                                     norm_drho, norm_drhoa, norm_drhob, rhoa, rhob, tau_a, tau_b
       TYPE(xc_derivative_type), POINTER        :: deriv
-      TYPE(xc_f90_pointer_t)                   :: xc_func, xc_info
+      TYPE(xc_f03_func_t)                      :: xc_func
+      TYPE(xc_f03_func_info_t)                 :: xc_info
 
       CALL timeset(routineN, handle)
 
@@ -637,20 +620,16 @@
       CPASSERT(ASSOCIATED(deriv_set))
       CPASSERT(deriv_set%ref_count > 0)
 
-      CALL section_vals_val_get(libxc_params, "functional", c_vals=func_name)
-      CALL section_vals_val_get(libxc_params, "scale", r_vals=scale)
+      CALL section_vals_val_get(libxc_params, "functional", c_val=func_name)
+      CALL section_vals_val_get(libxc_params, "scale", r_val=func_scale)
       CALL section_vals_val_get(libxc_params, "parameters", r_vals=params)
 
-      IF ((SIZE(scale) == 1) .AND. (ABS(SCALE(1)-1.0_dp) < 1.0e-10_dp)) THEN
-         sc = 1.0_dp
-      ELSE
-         sc = SCALE(ifunc_name)
-      ENDIF
+      IF (ABS(func_scale-1.0_dp) < 1.0e-10_dp) func_scale = 1.0_dp
 
-      func_id = xc_libxc_wrap_functional_get_number(func_name(ifunc_name))
-      CALL xc_libxc_wrap_functional_buggy(func_id, grad_deriv=grad_deriv)
+      func_id = xc_libxc_wrap_functional_get_number(func_name)
 !$OMP CRITICAL(libxc_init)
-      CALL xc_f90_func_init(xc_func, xc_info, func_id, XC_POLARIZED)
+      CALL xc_f03_func_init(xc_func, func_id, XC_POLARIZED)
+      xc_info = xc_f03_func_get_info(xc_func)
 !$OMP END CRITICAL(libxc_init)
 !$OMP BARRIER
 
@@ -744,7 +723,7 @@
          CALL xc_derivative_get(deriv, deriv_data=e_0)
       END IF
       IF (grad_deriv >= 1 .OR. grad_deriv == -1) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rhoa)", &
                                             allocate_deriv=.TRUE.)
@@ -799,11 +778,11 @@
                CALL xc_derivative_get(deriv, deriv_data=e_laplace_rhob)
             END IF
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 2 .OR. grad_deriv == -2) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rhoa)(rhoa)", &
                                             allocate_deriv=.TRUE.)
@@ -1002,11 +981,11 @@
             !                CALL xc_derivative_get(deriv,deriv_data=e_laplace_rhob_tau_b)
             !             END IF
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 3 .OR. grad_deriv == -3) THEN
-         SELECT CASE (xc_f90_info_family (xc_info))
+         SELECT CASE (xc_f03_func_info_get_family (xc_info))
          CASE (XC_FAMILY_LDA)
             deriv => xc_dset_get_derivative(deriv_set, "(rhoa)(rhoa)(rhoa)", &
                                             allocate_deriv=.TRUE.)
@@ -1023,7 +1002,7 @@
          CASE (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA, XC_FAMILY_MGGA)
             CPABORT("derivatives larger than 2 not implemented")
          CASE default
-            CPABORT(TRIM(func_name(ifunc_name))//": this XC_FAMILY is currently not supported.")
+            CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
          END SELECT
       END IF
       IF (grad_deriv >= 4 .OR. grad_deriv <= -4) THEN
@@ -1052,7 +1031,7 @@
 !$OMP SHARED(e_rhoa_rhoa_rhoa,e_rhoa_rhoa_rhob,e_rhoa_rhob_rhob,e_rhob_rhob_rhob),&
 !$OMP SHARED(grad_deriv,npoints),&
 !$OMP SHARED(epsilon_rho,epsilon_tau),&
-!$OMP SHARED(func_name,ifunc_name,sc,params)
+!$OMP SHARED(func_name,func_scale,params)
 
       CALL libxc_lsd_calc(rhoa=rhoa, rhob=rhob, norm_drho=norm_drho, &
                           norm_drhoa=norm_drhoa, norm_drhob=norm_drhob, laplace_rhoa=laplace_rhoa, &
@@ -1098,17 +1077,21 @@
                           e_rhob_rhob_rhob=e_rhob_rhob_rhob, &
                           grad_deriv=grad_deriv, npoints=npoints, &
                           epsilon_rho=epsilon_rho, &
-                          epsilon_tau=epsilon_tau, func_name=func_name(ifunc_name), &
-                          sc=sc, params=params)
+                          epsilon_tau=epsilon_tau, func_name=func_name, &
+                          sc=func_scale, params=params)
 
 !$OMP END PARALLEL
 
       NULLIFY (dummy)
 
-      CALL xc_f90_func_end(xc_func)
+      CALL xc_f03_func_end(xc_func)
 
       CALL timestop(handle)
 #else
+      MARK_USED(rho_set)
+      MARK_USED(deriv_set)
+      MARK_USED(grad_deriv)
+      MARK_USED(libxc_params)
       CPABORT("In order to use libxc you need to download and install it")
 #endif
    END SUBROUTINE libxc_lsd_eval
